Index: /trunk/seguranca/classes_BKP/Verifica_Certificado.php
===================================================================
--- /trunk/seguranca/classes_BKP/Verifica_Certificado.php	(revision 1035)
+++ /trunk/seguranca/classes_BKP/Verifica_Certificado.php	(revision 1035)
@@ -0,0 +1,157 @@
+<?php
+require_once('Verifica_Certificado_conf.php');
+require_once('funcoes_auxiliares.php');
+
+class Verifica_Certificado 
+{
+	public $msgerro = '';
+	public $revogado = false;
+	public $status = false;
+	public $certificado = '';
+	public $CRL = '';
+        public $erros_ssl = array();
+	public $arquivos_para_deletar = array();
+	
+	
+	public function __construct($parametro1,$parametro2)
+	{	
+		//include('Verifica_Certificado_conf.php');
+	        # $parametro1 = array com dados do certificado... 
+		# $parametro2 = certificado no formato PEM ...
+		$this->status = false;
+		if(!verificaopenssl())
+		{
+			$this->msgerro = 'MSG005i - Modulo openssl nao disponivel no PHP.';
+			return false;
+		}
+		If(!$parametro2)
+		 {
+			$this->msgerro = 'MSG005 - Certificado nao informado.';
+			return false;		
+		 }
+		$this->certificado = $parametro2; 
+		$aux = explode('/',$parametro1['CRLDISTRIBUTIONPOINTS']);
+		$this->CRL = $aux[count($aux)-1];	
+		
+		if(!$this->cmd_openssl_verify($this->certificado))
+		 {
+			$this->msgerro = 'MSG010- Erro verificando Expiracao/CAs do certificado.';
+			return false;		 
+		 }
+		 
+		if($this->Testa_se_Certificado_Revogado(trim($GLOBALS['CRLs'].$this->CRL),$parametro1['SERIALNUMBER']))
+		 {
+			$this->msgerro = 'MSG011- Ocorreu erro validando o certificado.';
+			return false;		 
+		 }		 
+		
+		$this->status = true;
+	}
+	
+  public function __destruct()
+  {
+		#Remover arquivos temporarios.....	
+		deleta_arquivos_temporarios(&$this->arquivos_para_deletar);
+  }
+  
+   private function cmd_openssl_verify($ZXZ)
+	{
+		$this->erros_ssl = array();
+		
+		if(!is_file($GLOBALS['CAs']))
+		{
+			# Se arquivo com cas nao existe, assume certificado invalido..
+			$this->erros_ssl[]= 'Autoridade certificadora desconhecida.(CA-01)';  //'Arquivo CAs nao localizado.';
+			return false;
+		}
+		
+		$arq = gera_nome_arquivo_temporario(&$this->arquivos_para_deletar);
+		if(!$arq)
+		 {
+			#Nao foi possivel gerar path(nome) para arquivo temporario...
+			$this->erros_ssl[]= 'Autoridade certificadora desconhecida.(CA-02)';  //'Arquivo CAs nao localizado.';
+			return false;
+		 }
+		 
+		$ret = grava_arquivo($arq,$this->certificado);
+		
+		$saida = array();
+
+		$w = exec('openssl verify -CAfile '.$GLOBALS['CAs'].' '.$arq,$saida);
+		deleta_arquivos_temporarios(&$this->arquivos_para_deletar);
+		$this->arquivos_para_deletar = array();
+		//echo 'w= '.$w.'<br>';
+		//echo '<pre>';
+		//print_r($saida);
+		//echo '</pre>';
+		$aux = explode(' ',$w);	
+		if($aux[1] != 'OK')   // OK no primeiro item do array significa que o comando executaou OK... mas tem erro no certificado...
+		{
+
+			foreach($saida as $item)
+			{
+			        $aux = explode(':',$item);
+				if(isset($aux[1]))
+				{
+					$this->erros_ssl[] = trim($aux[1]);
+				}
+			}			
+			return false;
+		}
+		return true;
+	}
+	
+	private function Testa_se_Certificado_Revogado($pcrl,$serial)
+	{
+		$this->erros_ssl = array();
+		
+		if(!file_exists($pcrl))
+			{
+				# Se arquivo com crls nao existe, assume certificado revogado..
+				$this->erros_ssl[]= 'Nao foi possivel verificar se o certificado esta revogado.(CD-01)';  //'Arquivo CRL nao localizado.';
+				return true;
+			}	
+			
+			if(!is_file($pcrl))
+			{
+				# Se nao for um arquivo, assume certificado revogado..
+				$this->erros_ssl[]= 'Nao foi possivel verificar se o certificado esta revogado.(CD-01)';  //'Arquivo CRL nao localizado.';
+				return true;
+			}
+
+
+		$crl = file_get_contents($pcrl,true);
+		$cert_data = Crl_parseASN($crl);
+
+                # testa se crl expirada....	
+		if(gmdate('YmdHis') >= data_hora($cert_data[1][0][1][4][1]))
+		{
+			# Se crl expirada, assume certificado revogado..
+			$this->erros_ssl[]= 'Nao foi possivel verificar se o certificado esta revogado.(CD-02)';  //'Arquivo CRL expirado.';
+			return true;
+		}
+		
+		if (!is_array($cert_data) || ($cert_data[0] == 'UNKNOWN')) 
+		{
+			# Se o primeiro parametro aponta uma crl invalida retorna como certificado revogado...
+			$this->erros_ssl[]='Nao foi possivel verificar se o certificado esta revogado.(CD-03)'; //Arquivo CRL invalido.
+			return true;
+		}
+
+		foreach($cert_data[1][0][1][5][1] as $item)
+		{
+			if($serial === $item[1][0][1])
+			{
+			#Certificado esta revogado mesmo !!!!! 
+			$this->erros_ssl[]=lang('REVOKED Certificate.');
+			$this->revogado = true;
+			return true;				
+			}
+		}
+
+		return false;
+	}	
+ 
+}	
+
+?>
Index: /trunk/seguranca/classes_BKP/funcoes_auxiliares.php
===================================================================
--- /trunk/seguranca/classes_BKP/funcoes_auxiliares.php	(revision 1035)
+++ /trunk/seguranca/classes_BKP/funcoes_auxiliares.php	(revision 1035)
@@ -0,0 +1,758 @@
+<?php
+//  Conjunto de funcoes de apoio as Classes de tratamento do certificado digital.
+		
+	function data_hora ($valor) 
+	{
+		$year  = substr($valor, 0, 2);
+		$month = substr($valor, 2, 2);
+		$day   = substr($valor, 4, 2);
+		$hour  = substr($valor, 6, 2);
+		$min   = substr($valor, 8, 2);
+		$sec   = substr($valor, 10, 2);
+		return gmdate('YmdHis',gmmktime($hour, $min, $sec, $month, $day, $year));
+	}
+
+	function gera_nome_arquivo_temporario($tab_arqs)
+	{
+		//include('Verifica_Certificado_conf.php');
+		if(!is_dir($GLOBALS['dirtemp']))
+		{
+			#Se nao existe uma area de trabalho aborta a funcao..
+			return false;
+		}
+		$lista = array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z');
+		$N = $lista[rand(0,count($lista)-1)].date('U').$lista[rand(0,count($lista)-1)].RAND(12345,9999999999).$lista[rand(0,count($lista)-1)].$lista[rand(0,count($lista)-1)].RAND(12345,9999999999).'.tmp';
+		$aux = $GLOBALS['dirtemp'].'/'.$N;;
+	        array_push($tab_arqs ,$aux); 
+		return  $aux;		
+	}
+	
+	function grava_arquivo($arquivo,$dados)
+	{
+		$ret = file_put_contents($arquivo,$dados);
+		if(!$ret)
+		{
+			return false;
+		}
+		else
+			return $ret;
+	}
+	
+	
+	function deleta_arquivos_temporarios($tab_arqs)
+	{
+		foreach($tab_arqs as $arquivo ){ unlink($arquivo); }	
+	}
+
+       	function verificaopenssl()
+	{
+		if(extension_loaded('openssl'))
+		{
+			return true;
+		}
+		else
+			return false;
+	}
+   
+        function Crl_parseASN($data)
+	{  
+		$_oids = array(
+			'2.5.4.3' => 'CN',
+			'2.5.4.4' => 'Surname',
+			'2.5.4.6' => 'C',
+			'2.5.4.7' => 'StateOrProvince',
+			'2.5.4.8' => 'Location',
+			'2.5.4.9' => 'StreetAddress',
+			'2.5.4.10' => 'O',
+			'2.5.4.11' => 'OU',
+			'2.5.4.12' => 'Title',
+			'2.5.4.20' => 'TelephoneNumber',
+			'2.5.4.42' => 'GivenName',
+			'2.5.29.14' => 'id-ce-subjectKeyIdentifier',
+			'2.5.29.15' => 'id-ce-keyUsage',
+			'2.5.29.17' => 'id-ce-subjectAltName',
+			'2.5.29.19' => 'id-ce-basicConstraints',
+			'2.5.29.20' => 'id-ce-cRLNumber',
+			'2.5.29.31' => 'id-ce-CRLDistributionPoints',
+			'2.5.29.32' => 'id-ce-certificatePolicies',
+			'2.5.29.35' => 'id-ce-authorityKeyIdentifier',
+			'2.5.29.37' => 'id-ce-extKeyUsage',
+			'1.2.840.113549.1.9.1' => 'Email',
+			'1.2.840.113549.1.1.1' => 'RSAEncryption',
+			'1.2.840.113549.1.1.2' => 'md2WithRSAEncryption',
+			'1.2.840.113549.1.1.4' => 'md5withRSAEncryption',
+			'1.2.840.113549.1.1.5' => 'SHA-1WithRSAEncryption',
+			'1.2.840.10040.4.3' => 'id-dsa-with-sha-1',
+			'1.3.6.1.5.5.7.3.2' => 'id_kp_clientAuth',
+			'1.3.6.1.5.5.7.3.4' => 'id_kp_securityemail',	
+			'1.3.6.1.5.5.7.2.1' => 'id_certificatePolicies',
+			'2.16.840.1.113730.1.1' => 'netscape-cert-type',
+			'2.16.840.1.113730.1.2' => 'netscape-base-url',
+			'2.16.840.1.113730.1.3' => 'netscape-revocation-url',
+			'2.16.840.1.113730.1.4' => 'netscape-ca-revocation-url',
+			'2.16.840.1.113730.1.7' => 'netscape-cert-renewal-url',
+			'2.16.840.1.113730.1.8' => 'netscape-ca-policy-url',
+			'2.16.840.1.113730.1.12' => 'netscape-ssl-server-name',
+			'2.16.840.1.113730.1.13' => 'netscape-comment',
+			'2.16.76.1.2.1' => 'A1',	
+			'2.16.76.1.2.3' => 'A3',	
+			'2.16.76.1.2.1.16' => 'Certification Practice Statement pointer',
+			'2.16.76.1.3.1' => 'Dados do cert parte 1',
+			'2.16.76.1.3.5' => 'Dados do cert parte 2',
+			'2.16.76.1.3.6' => 'Dados do cert parte 3',	
+				);
+    
+		$result = array();
+		$rxyz = array();
+		
+		while (strlen($data) > 1) 
+		{
+			$class = ord($data[0]);
+			switch ($class) 
+			{
+			case 0x30:
+				// Sequence
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+				
+				$sequence_data = substr($data, 2 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+
+				$values = Crl_parseASN($sequence_data);
+				if (!is_array($values) || is_string($values[0])) 
+				{
+					$values = array($values);
+				}
+				$sequence_values = array();
+				$i = 0;
+				foreach ($values as $val) 
+				{
+					if ($val[0] == 'extension') 
+					{
+						$sequence_values['extensions'][] = $val;
+					} 
+					else 
+					{
+						$sequence_values[$i++] = $val;
+					}
+				}
+				$result[] = array('sequence', $sequence_values);
+				break;
+
+			case 0x31:
+				// Set of
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+				$sequence_data = substr($data, 2 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+				$result[] = array('set', Crl_parseASN($sequence_data));
+				break;
+
+			case 0x01:
+				// Boolean type
+				$boolean_value = (ord($data[2]) == 0xff);
+				$data = substr($data, 3);
+				$result[] = array('boolean', $boolean_value);
+				break;
+			
+			case 0x02:
+				// Integer type
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+
+				$integer_data = substr($data, 2 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+				if($len == 16)
+				{
+					$result[] = array('integer(' . $len . ')', $integer_data);
+					break;
+				}
+				else
+				{
+								$value = 0;
+				if ($len <= 4) 
+				{
+					// Method works fine for small integers
+					for ($i = 0; $i < strlen($integer_data); $i++) 
+					{
+						$value = ($value << 8) | ord($integer_data[$i]);
+					}
+				} 
+				else 
+				{
+					// Method works for arbitrary length integers 
+					if (extension_loaded('bcmath')) 
+					{
+						for ($i = 0; $i < strlen($integer_data); $i++) 
+						{
+							$value = bcadd(bcmul($value, 256), ord($integer_data[$i]));
+						}
+					} 
+					else 
+					{
+						$value = -1;
+					}
+				}
+				$result[] = array('integer(' . $len . ')', $value);
+				break;
+				}
+			/*
+			case 0x02:
+				// Integer type
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+
+				$integer_data = substr($data, 2 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+
+				$value = 0;
+				if ($len <= 4) 
+				{
+					// Method works fine for small integers
+					for ($i = 0; $i < strlen($integer_data); $i++) 
+					{
+						$value = ($value << 8) | ord($integer_data[$i]);
+					}
+				} 
+				else 
+				{
+					// Method works for arbitrary length integers 
+					if (extension_loaded('bcmath')) 
+					{
+						for ($i = 0; $i < strlen($integer_data); $i++) 
+						{
+							$value = bcadd(bcmul($value, 256), ord($integer_data[$i]));
+						}
+					} 
+					else 
+					{
+						$value = -1;
+					}
+				}
+				$result[] = array('integer(' . $len . ')', $value);
+				break;
+		        */  
+			case 0x03:
+				// Bitstring type
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+				$bitstring_data = substr($data, 3 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+				$result[] = array('bit string',$bitstring_data);
+				break;
+
+			case 0x04:
+				// Octetstring type
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+				$octectstring_data = substr($data, 2 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+				$result[] = array('octet string', $octectstring_data);
+				break;
+
+			case 0x05:
+				// Null type
+				$data = substr($data, 2);
+				$result[] = array('null', null);
+				break;
+
+			case 0x06:
+				// Object identifier type
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+				$oid_data = substr($data, 2 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+
+				// Unpack the OID
+				$plain  = floor(ord($oid_data[0]) / 40);
+				$plain .= '.' . ord($oid_data[0]) % 40;
+
+				$value = 0;
+				$i = 1;
+				while ($i < strlen($oid_data)) 
+				{
+					$value = $value << 7;
+					$value = $value | (ord($oid_data[$i]) & 0x7f);
+
+					if (!(ord($oid_data[$i]) & 0x80)) 
+					{
+						$plain .= '.' . $value;
+						$value = 0;
+					}
+					$i++;
+				}
+				//echo $plain.' === '.$_oids[$plain].'<br>';
+				if (isset($_oids[$plain])) 
+				{
+					$result[] = array('oid', $_oids[$plain]);
+				} 
+				else 
+				{
+					$result[] = array('oid', $plain);
+				}
+				break;
+
+			case 0x12:
+			case 0x13:
+			case 0x14:
+			case 0x15:
+			case 0x16:
+			case 0x81:
+			case 0x80:
+				// Character string type
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+				$string_data = substr($data, 2 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+				$result[] = array('string', $string_data);
+				break;
+
+			case 0x17:
+				// Time types
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+				$time_data = substr($data, 2 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+				$result[] = array('utctime', $time_data);
+				break;
+
+			case 0x82:
+				// X509v3 extensions?
+				$len = ord($data[1]);
+				$bytes = 0;
+				if ($len & 0x80) 
+				{
+					$bytes = $len & 0x0f;
+					$len = 0;
+					for ($i = 0; $i < $bytes; $i++) 
+					{
+						$len = ($len << 8) | ord($data[$i + 2]);
+					}
+				}
+				$sequence_data = substr($data, 2 + $bytes, $len);
+				$data = substr($data, 2 + $bytes + $len);
+				$result[] = array('extension', 'X509v3 extensions');
+				$result[] = Crl_parseASN($sequence_data);
+				break;
+
+			case 0xa0:
+			case 0xa3:
+				// Extensions
+				$extension_data = substr($data, 0, 2);
+				$data = substr($data, 2);
+				$result[] = array('extension', dechex($extension_data));
+				break;
+
+			case 0xe6:
+				$extension_data = substr($data, 0, 1);
+				$data = substr($data, 1);
+				$result[] = array('extension', dechex($extension_data));
+				break;
+
+			case 0xa1:
+				$extension_data = substr($data, 0, 1);
+				$data = substr($data, 6);
+				$result[] = array('extension', dechex($extension_data));
+				break;
+
+			default:
+				// Unknown
+				$result[] = array('UNKNOWN', dechex($data));
+				$data = '';
+				break;
+			}
+        }
+
+        return (count($result) > 1) ? $result : array_pop($result);
+
+   }
+   
+   function openssl_to_timestamp ($in) 
+   {
+	$year  = substr($in, 0, 4); /* NOTE: Yes, this returns a two digit year */
+        $month = substr($in, 4, 2);
+        $day   = substr($in, 6, 2);
+        $hour  = substr($in, 8, 2);
+        $min   = substr($in, 10, 2);
+        $sec   = substr($in, 12, 2);
+    
+        return gmmktime($hour, $min, $sec, $month, $day, $year);
+	}
+
+#============================================================================================
+#============================================================================================
+#============================================================================================
+
+# Transforma o certificado do formato PEM para o formato DER ...
+function pem2der($pem_data) 
+	{
+		$begin = "CERTIFICATE-----";
+		$end   = "-----END";
+		$pem_data = substr($pem_data, strpos($pem_data, $begin)+strlen($begin));    
+		$pem_data = substr($pem_data, 0, strpos($pem_data, $end));
+		$der = base64_decode($pem_data);
+		return $der;
+	}
+
+# Recupera dados da oid passada como parametro.....
+function parse($oid,$valor)
+	{
+		$oids = array('1.3.1' => array('1'=>array('NASCIMENTO',8),
+		                                               '2'=>array('CPF',11),
+							       '3'=>array('NIS',11),
+							       '4'=>array('RG',15),
+							       '5'=>array('ORGAOUF',6)),
+				     '1.3.5' => array('1'=>array('TITULO',12),
+				                              '2'=>array('ZONA',3),
+							      '3'=>array('SECAO',4),
+							      '4'=>array('TITULO_CIDADE_UF',0)),
+				     '1.3.6' => array('1'=>array('CADINSS',12))); 
+				     
+		$resultado = array(); 
+		$esta_oid = $oids[$oid];
+		$X = intval(substr($oid,4,1));
+		$p = 0;
+		for($i=1;$i < count($esta_oid) + 1; $i++)
+			{
+				if($esta_oid[$i][1] == 0)
+					{
+						# se igual a zero, então esta apontando um ultimo elemento, iniciando em $p, até o fim dos dados
+						$tamanho = strlen($valor) - $p;
+					}
+				else
+					{
+						$tamanho = $esta_oid[$i][1];
+					} 
+				$resultado[$esta_oid[$i][0]] = substr($valor,$p,$tamanho);
+				$p = $p + $esta_oid[$i][1];
+			}
+		return $resultado;
+	}  
+
+function subjectAltName($cert_data,$KK)
+	{
+	        $dados = array();
+		$AUX = Crl_parseASN( $cert_data[1][0][1][$KK][1][1][1]);
+		$P1 = $AUX[1][1][1];
+		$P2 = $AUX[1][3][1];
+		$P3 = $AUX[1][5][1];
+		$P4 = $AUX[1][6][1];	
+		$dados = array_merge(parse('1.3.1',$P1),
+					parse('1.3.5',$P2),
+					parse('1.3.6',$P3),$dados);
+		$dados['EMAIL'] = $P4;
+		
+		return $dados;
+	}
+	
+function subjectAltName_B($cert_data,$KK)
+	{
+	        $dados = array();
+		$AUX = Crl_parseASN($KK);
+		//echo '<pre>';
+		//print_r($AUX);
+		//echo '</pre>';
+		if(is_array($AUX[0]))
+		{
+			$AUXx = $AUX[0];
+			$AUX = $AUXx;
+		}
+		$P1 = $AUX[1][1][1];
+		$P2 = $AUX[1][3][1];
+		$P3 = $AUX[1][5][1];
+		$P4 = $AUX[1][6][1];	
+		$dados = array_merge(parse('1.3.1',$P1),
+					parse('1.3.5',$P2),
+					parse('1.3.6',$P3),$dados);
+		if($P4 != '1.3.6.1.4.1.311.20.2.3')   // esta oid indica domínio de login em estações de trabalho . Pegar o 2. item como email.
+			{
+				$dados['EMAIL'] = $P4;
+			}
+		else
+			{
+				$dados['EMAIL'] = $AUX[1][8][1];			
+			}
+			
+		return $dados;
+	}
+
+function CRLDistributionPoints($cert_data,$KK)
+	{
+		$dados = array();
+		$AUX = explode('http:',$cert_data[1][0][1][$KK][1][1][1]);
+		if($AUX[1])
+			{
+				$dados['CRLDISTRIBUTIONPOINTS'] = 'http:' . $AUX[1];
+			}
+		else
+			{
+				$dados['CRLDISTRIBUTIONPOINTS'] = '';
+			}
+			
+		return $dados;		
+	}	
+	
+function SERIALNUMBER($cert_data,$KK)
+	{
+		$dados = array();
+		$dados['SERIALNUMBER'] = $cert_data[1][0][1][$KK][1];
+
+		return $dados;			
+	}
+	
+function SUBJECT($cert_data,$KK)
+	{
+		$dados = array();
+		$AUX1 = '/';
+		foreach($cert_data[1][0][1][$KK][1] as $AUX2)
+			{
+				$AUX1 .= $AUX2[1][1][0][1] . '=' . $AUX2[1][1][1][1] . '/';
+			}
+		$dados['SUBJECT'] = substr($AUX1,0,strlen($AUX1)-1);
+		$AUX1 = explode('CN=',$dados['SUBJECT']);
+		$AUX2 = explode('/',$AUX1[1]);
+		$AUX3 = explode(':',$AUX2[0]);
+		$dados['NOME'] = $AUX3[0];
+		return $dados;			
+	}
+		
+function ISSUER($cert_data,$KK)		
+	{
+		$dados = array();	
+		$AUX1 = '/';
+		foreach($cert_data[1][0][1][$KK][1] as $AUX2)
+			{
+				$AUX1 .= $AUX2[1][1][0][1] . '=' . $AUX2[1][1][1][1] . '/';
+			}
+		$AUX1 = explode('CN=',substr($AUX1,0,strlen($AUX1)-1));
+		$AUX2 = explode('/',$AUX1[1]);
+		$dados['EMISSOR'] = $AUX2[0];
+		
+		return $dados;	
+		
+		}		
+
+function BEFOREAFTER($cert_data,$KK)
+	{
+		$dados = array();
+		$dados['INICIO_VALIDADE'] = data_hora($cert_data[1][0][1][$KK][1][0][1]);
+		$dados['FIM_VALIDADE'] = data_hora($cert_data[1][0][1][$KK][1][1][1]);
+		$agora = date('YmdHis');
+		if(($agora < $dados['INICIO_VALIDADE']) || ($agora > $dados['FIM_VALIDADE']))
+			{
+				$dados['EXPIRADO'] = true;
+			}
+		else
+			{
+				$dados['EXPIRADO'] = false;
+			}	
+		return $dados;		
+		}	
+
+function AUTHORITYKEYIDENTIFIER($cert_data,$KK)
+	{
+		$dados = array();
+		$aux1 = Crl_parseASN( $cert_data[1][0][1][$KK][1][1][1]);
+		$aux2='';
+		if (isset($aux1[1][0][1]))
+		{
+			$tab_val = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'); 
+			for($A=0;$A<strlen($aux1[1][0][1]);$A++)
+				{
+					$aux_parte_numerica =ord(substr($aux1[1][0][1],$A,1)) % 16;
+					$aux_parte_zona = (ord(substr($aux1[1][0][1],$A,1)) - $aux_parte_numerica) / 16;
+					$parte_numerica = $tab_val[$aux_parte_numerica];
+					$parte_zona = $tab_val[$aux_parte_zona];
+					$aux2 .=  $parte_zona.$parte_numerica;
+				}
+			$dados['AUTHORITYKEYIDENTIFIER'] = $aux2;
+		}
+		else
+			{
+				$dados['AUTHORITYKEYIDENTIFIER'] = "auto-assinado";
+			}
+		return $dados;			
+	}
+	
+function AUTHORITYKEYIDENTIFIER_B($cert_data,$KK)
+	{
+		$dados = array();
+		$aux2='';
+		if (isset($KK))
+		{
+			$tab_val = array('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'); 
+			for($A=0;$A<strlen($KK);$A++)
+				{
+					$aux_parte_numerica =ord(substr($KK,$A,1)) % 16;
+					$aux_parte_zona = (ord(substr($KK,$A,1)) - $aux_parte_numerica) / 16;
+					$parte_numerica = $tab_val[$aux_parte_numerica];
+					$parte_zona = $tab_val[$aux_parte_zona];
+					$aux2 .=  $parte_zona.$parte_numerica;
+				}
+			$dados['AUTHORITYKEYIDENTIFIER'] = $aux2;
+		}
+		else
+			{
+				$dados['AUTHORITYKEYIDENTIFIER'] = "auto-assinado";
+			}
+		return $dados;			
+	}
+
+function recupera_dados_do_ceritificado_digital($certificado_digital_formato_pem)
+	{
+	        $X509_PARSE = openssl_x509_parse($certificado_digital_formato_pem);
+		$cert_der =  pem2der($certificado_digital_formato_pem);
+		$aux11 = explode(chr(0x30).chr(0x16).chr(0x80).chr(0x14),$cert_der);
+		//echo '<pre>';
+		//print_r( $aux11);
+		//echo '</pre>';
+		$caid = substr($aux11[1],0,20);
+                $aux11 = explode(chr(0x30).chr(0x81),$cert_der);
+		
+		//echo '<pre>';
+		//print_r( Crl_parseASN(chr(0x30).chr(0x81).$aux11[6]));
+		//echo '</pre>';
+		
+		//$oids_icp = $X509_PARSE['extensions']['subjectAltName'];
+		if(count($aux11)<9)
+			{
+				$ky = 6;
+			}
+		else
+			{
+				$ky = 5;
+			}
+		$oids_icp = chr(0x30).chr(0x81).$aux11[$ky];
+		
+		$funcoes = array(1 => SERIALNUMBER,
+			   3 =>  ISSUER,
+			   4 => BEFOREAFTER,
+			   5 => SUBJECT,
+			   $caid => AUTHORITYKEYIDENTIFIER_B,
+			   $oids_icp => subjectAltName_B);
+			   
+		$dados=array();
+		$cert_data = Crl_parseASN( $cert_der);
+		foreach($funcoes as $parametro => $funcao)
+			{
+				$dados= array_merge($dados,$funcao($cert_data,$parametro));
+			}
+
+		if(!$dados['EMAIL'])
+			{
+				$AUX2 = explode('Email=',$dados['SUBJECT']);
+				$dados['EMAIL'] = $AUX2[1];
+			}
+			
+                if($dados['EMAIL'] == '')
+			{
+				$x = ord(substr($aux11[$ky+1],0)); 
+				$dados['EMAIL'] = substr($aux11[$ky+1],1,$x);
+			}
+
+		if(!$dados['CRLDISTRIBUTIONPOINTS'])
+			{
+				$AUX1 =  explode('http:',$X509_PARSE['extensions']['crlDistributionPoints']);
+				$AUX2 = explode('.crl',$AUX1[1]);
+				if($AUX2[0])
+					{
+						$dados['CRLDISTRIBUTIONPOINTS'] = 'http:' . $AUX2[0] . '.crl';
+					}
+				else
+					{
+						$AUX1 = explode('.crl', $cert_der);
+						$AUX2 = explode('http:',$AUX1[0]);
+						$dados['CRLDISTRIBUTIONPOINTS'] = 'http:' .$AUX2[1] . '.crl';
+					}
+			}
+			
+		return $dados;		
+	
+	}
+
+#============================================================================================
+#============================================================================================
+#============================================================================================
+
+?>
Index: /trunk/seguranca/classes/Verifica_Certificado_conf.php
===================================================================
--- /trunk/seguranca/classes/Verifica_Certificado_conf.php	(revision 1035)
+++ /trunk/seguranca/classes/Verifica_Certificado_conf.php	(revision 1035)
@@ -0,0 +1,5 @@
+<?php
+$GLOBALS['dirtemp']  =   '/var/www/expresso/seguranca/temp'; 
+$GLOBALS['CAs']  =         '/var/www/expresso/seguranca/cas/todos.cer';
+$GLOBALS['CRLs']  =       '/var/www/expresso/seguranca/crls/'; 
+?>
